# $Id: /mirror/youri/soft/check/trunk/lib/Youri/Check/Test/MandrivaConflicts.pm 1379 2006-12-01T00:25:58.801086Z guillomovitch  $
package Youri::Check::Test::MandrivaConflicts;

=head1 NAME

Youri::Check::Test::MandrivaConflicts - Check file conflicts on Mandriva

=head1 DESCRIPTION

This class checks file conflicts between packages, taking care of Mandriva
packaging policy.

=cut

use warnings;
use strict;
use Carp;
use Youri::Package;
use base 'Youri::Check::Test::Conflicts';

sub _directory_duplicate_exception {
    my ($self, $package1, $package2, $file) = @_;

    # allow shared directories between devel packages of different arch
    return 1 if _multiarch_exception($package1, $package2);

    # allow shared modules directories between perl packages
    my $name = $file->get_name();
    return 1 if 
        $name =~ /^\/usr\/lib\/perl5\/vendor_perl\// &&
        $name !~ /^(auto|[^\/]+-linux)$/;

    return 0;
}

sub _file_duplicate_exception {
    my ($self, $package1, $package2, $file) = @_;

    # allow shared files between devel packages of different arch
    return 1 if _multiarch_exception($package1, $package2);

    return 0;
}

sub _multiarch_exception {
    my ($package1, $package2) = @_;

    return 1 if
        $package1->get_canonical_name() eq $package2->get_canonical_name()
        && $package1->get_name() =~ /-devel$/
        && $package2->get_name() =~ /-devel$/;

    return 0;
}

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2002-2006, YOURI project

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

=cut

1;
